// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2017-2021 Authors of Cilium
// SPDX-License-Identifier: Apache-2.0

package service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/cilium/cilium/api/v1/models"
)

// DeleteServiceIDReader is a Reader for the DeleteServiceID structure.
type DeleteServiceIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteServiceIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteServiceIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 404:
		result := NewDeleteServiceIDNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewDeleteServiceIDFailure()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewDeleteServiceIDOK creates a DeleteServiceIDOK with default headers values
func NewDeleteServiceIDOK() *DeleteServiceIDOK {
	return &DeleteServiceIDOK{}
}

/*DeleteServiceIDOK handles this case with default header values.

Success
*/
type DeleteServiceIDOK struct {
}

func (o *DeleteServiceIDOK) Error() string {
	return fmt.Sprintf("[DELETE /service/{id}][%d] deleteServiceIdOK ", 200)
}

func (o *DeleteServiceIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewDeleteServiceIDNotFound creates a DeleteServiceIDNotFound with default headers values
func NewDeleteServiceIDNotFound() *DeleteServiceIDNotFound {
	return &DeleteServiceIDNotFound{}
}

/*DeleteServiceIDNotFound handles this case with default header values.

Service not found
*/
type DeleteServiceIDNotFound struct {
}

func (o *DeleteServiceIDNotFound) Error() string {
	return fmt.Sprintf("[DELETE /service/{id}][%d] deleteServiceIdNotFound ", 404)
}

func (o *DeleteServiceIDNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewDeleteServiceIDFailure creates a DeleteServiceIDFailure with default headers values
func NewDeleteServiceIDFailure() *DeleteServiceIDFailure {
	return &DeleteServiceIDFailure{}
}

/*DeleteServiceIDFailure handles this case with default header values.

Service deletion failed
*/
type DeleteServiceIDFailure struct {
	Payload models.Error
}

func (o *DeleteServiceIDFailure) Error() string {
	return fmt.Sprintf("[DELETE /service/{id}][%d] deleteServiceIdFailure  %+v", 500, o.Payload)
}

func (o *DeleteServiceIDFailure) GetPayload() models.Error {
	return o.Payload
}

func (o *DeleteServiceIDFailure) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
